/*******************************************************************************
    Cannavo' Michele (Mikelius)
    v.1.0.0.0 del 13/04/2017
    Rilasciata con Licenza GNU GPLv3.0
    COPYRIGHT (C) 2017 Cannavo' Michele

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*******************************************************************************/

#ifndef ELENCOFILDER_H
#define ELENCOFILDER_H
#pragma once
// doppia include guard

#include <io.h>
#include <stdlib.h>
#include <stdio.h>

//////////////////////////////////// DEFINE ////////////////////////////////////
#define STCDATAF struct _finddata_t

///////////////////////////////////// ENUM /////////////////////////////////////
typedef enum _TYPEF{
    TFOLDER   = 0,           /// RAPPRESENTA UNA CARTELLA
    TFILE     = 1            /// RAPPRESENTA UN FILE
}TYPEF;

typedef enum _BOOL{
    MYFALSE   = 0,           /// RAPPRESENTA 0, FALSO
    MYTRUE    = !MYFALSE     /// RAPPRESENTA 1, VERO
}BOOL;

typedef enum _MYRETURN{
    FATALITY  = -1,          /// ERRORE GRAVE
	SUCCESS   =  0,          /// FUNZIONE RIUSCITA/RISULTATO POSITIVO
	INSUCCESS =  1           /// ERRORI GENERICI/RISULTATO NEGATIVO
}MYRETURN;

typedef enum MODEACCESS{
    EXISTS     = 0,
    ONLY_READ  = 2,
    ONLY_WRITE = 4,
    READ_WRITE = 6,
}MODEACCESS;

//////////////////////////////////// STRUCT ////////////////////////////////////
typedef struct _DIRDATA{
    int        levSubF;      //!< Livello di SubFolder
    BOOL       recSearch;
   // char       szBuf[1024];
  //  int        nIndent;
    BOOL       fOk;
    BOOL       fIsDir;
    STCDATAF  FindData;
} DIRDATA;

typedef struct listFILDER{
    char name[260];
    struct listtFILDER *next;
}listFILDER;



///////////////////////////// DEFINIZIONI FUNZIONI /////////////////////////////
MYRETURN  searchF( const char* path, BOOL recSearch, FILE** pf );
MYRETURN elencoFilder( DIRDATA* pStcData,FILE** pf );
MYRETURN isFolder( STCDATAF *file );
BOOL findNextDir( long hFilder, STCDATAF *lpFindData );
long findFirstDir( char* pattern, STCDATAF *lpFindData );

MYRETURN myfopen( FILE** streamF, const char* name, const char* mode );
MYRETURN myfclose( FILE** ptrptrFile );
MYRETURN myAccess( const char* nameFilder, MODEACCESS mode );
MYRETURN mygetcwd( char **path, int maxSize );
MYRETURN mychdir( const char *dirname );
MYRETURN mymkdir( const char *dirname );

#endif