/*******************************************************************************
    Cannavo' Michele (Mikelius)
    v.1.0.0.0 del 13/04/2017
    Rilasciata con Licenza GNU LESSER LGPLv3.0
    COPYRIGHT (C) 2017 Cannavo' Michele

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU LESSER General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU LESSER General Public License for more details.

    You should have received a copy of the GNU LESSER General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*******************************************************************************/
#include <stdio.h>
#include <direct.h>
#include <stdlib.h>
#include <errno.h>
#include "elencoFilder.h"

MYRETURN mychdir(const char *dirname)
{
	if (dirname == NULL){
   //     printf("ERRORE IN INPUT: DIRNAME=(NULL)\n");
        return FATALITY;
	}

	if (_chdir(dirname) == 0){
		return SUCCESS;
	}else{
//        perror("IMPOSSIBILE SETTARE LA DIRECTORY:\n");
        return INSUCCESS;
	}
}

MYRETURN mygetcwd(char **path,int maxsize)
{
    if( path == NULL || *path == NULL){
 //       printf( "ERRORE IN INPUT: PATH=(NULL)\n" );
        return FATALITY;
    }

    if( ((*path) = _getcwd( NULL, maxsize )) != NULL ){
        return SUCCESS;
    }else{
//		perror("IMPOSSIBILE OTTENERE LA DIRECTORY:");
		return INSUCCESS;
	}
}

MYRETURN myAccess( const char* nameFilder, MODEACCESS mode )
{
    if( nameFilder == NULL ){
   //     printf( "INPUT ERROR: [nameFilder] IS (null)\n" );
        return FATALITY;
    }

    switch( mode ){
    case EXISTS:
        if( _access_s( nameFilder, 00 ) == 0 ){ // Solo esistenza
      //      printf( "[%s]-> TEST EXISTS = OK!\n", nameFilder );
            return SUCCESS;
        } else{
      //      printf( "[%s]-> TEST EXISTS = FAILURE!\n", nameFilder );
            return INSUCCESS;
        }

    case ONLY_READ:
        if( _access_s( nameFilder, 02 ) == 0 ){ // Solo lettura
      //      printf( "[%s]-> TEST READ = OK!\n", nameFilder  );
            return SUCCESS;
        } else{
      //      printf( "[%s]-> TEST READ = FAILURE!\n", nameFilder  );
            return INSUCCESS;
        }

    case ONLY_WRITE:
        if( _access_s( nameFilder, 04 ) == 0 ){ // Solos scrittura
     //       printf( "[%s]-> TEST WRITE = OK!\n", nameFilder  );
            return SUCCESS;
        } else{
     //       printf( "[%s]-> TEST WRITE = FAILURE!!\n", nameFilder  );
            return INSUCCESS;
        }

    case READ_WRITE:
        if( _access_s( nameFilder, 06 ) == 0 ){ // Lettura e Scrittura
      //      printf( "[%s]-> TEST READ AND WRITE = OK!\n", nameFilder  );
            return SUCCESS;
        } else{
     //       printf( "[%s]-> TEST READ AND WRITE = FAILURE!!\n", nameFilder  );
            return INSUCCESS;
        }

    default:
    //    printf( "AUTHORIZATION MODE NOT SUPPORTED" );
        return FATALITY;
    }
}

MYRETURN mymkdir(const char *dirname)
{
	if (dirname == NULL){

		return FATALITY;
	}

	if (_mkdir(dirname) == 0){
	//	printf("Directory %s was successfully created\n",dirname);
		return SUCCESS;
	}else{
	//	printf("Problem creating directory [%s]\n", dirname);
		switch (errno)
		{
		case EEXIST:
	//		printf("%s Already exists\n", dirname);
			break;

		case ENOENT:
		//	printf("Percorso non trovato\n");
			break;
		default:
		//	printf("Unknown error.\n");
			break;
		}
		return INSUCCESS;
	}

}