/*******************************************************************************
    Cannavo' Michele (Mikelius)
    v.1.0.0.0 del 13/04/2017
    Rilasciata con Licenza GNU LESSER LGPLv3.0
    COPYRIGHT (C) 2017 Cannavo' Michele

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU LESSER General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU LESSER General Public License for more details.

    You should have received a copy of the GNU LESSER General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*******************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "elencoFilder.h"

// Elenco delle modalit di apertura file supportate
const char mymode[12][3] = {
    "r","w","a",
    "r+","w+","a+",
    "rb","wb","ab",
    "rt","wt","at",
};

MYRETURN myfopen( FILE** streamF,const char* name, const char* mode )
{
    size_t i = 0;
//////////////////////////////// CONTROLLO INPUT //////////////////////////////
	if((*streamF) == NULL ||  streamF == NULL) {
		printf( "INPUT ERROR: [Stream] IS (null)" );
		return FATALITY;
	}
	if( name == NULL ) {
        printf( "INPUT ERROR: [name] IS (null)" );
		return FATALITY;
	}
	if( mode == NULL ) {
		printf( "INPUT ERROR: [mode] IS (null)" );
		return FATALITY;
	}

//////////////////////////////// CONTROLLO MODE ////////////////////////////////
    while(strncmp( mode, mymode[i++], 3 ) ) {
        if( i == 12 ){
            printf( "THE [MODE=%s] IS NOT SUPPORTATED", mode );
            return FATALITY;
        }
    }

    // controllo la riuscita della funzione
	if( fopen_s( streamF, name, mode ) ) {
		perror( "Impossibile Aprire il File: ");
		return FATALITY;// File non aperto
	} else{
        return SUCCESS;
    } // File aperto.
}
MYRETURN myfclose( FILE** ptrptrFile )
{
	if(NULL == ptrptrFile || NULL == *ptrptrFile ) {
		printf( "INPUT ERROR: [ptrFile] IS (null)" );
		return FATALITY;// Se uno dei 2 puntatori e' null la funzione fallisce
	}

	if( fclose( *ptrptrFile )) { // cerco di chiudere il FILE
		perror( "Impossibile Chiudere il file: " );
		return INSUCCESS;
	} else{
        *ptrptrFile = NULL; // Per evitare di riutilizzarlo per errore
        return SUCCESS;
    }
}